#include <iostream.h>
#include "polonaise.hh"
#include "nommage.hh"



int main (int argc, char **argv) 
{


//
// Initialisation standard CORBA
//
CORBA::ORB_ptr orb = CORBA::ORB_init(argc,argv,"omniORB2");
CORBA::BOA_ptr boa = orb->BOA_init(argc,argv,"omniORB2_BOA");


try {


	//
	// On construit le nom du service
	// souhaite
	//
	CosNaming::Name nom;
	nom.length(2);

	nom[0].id   = (const char*) "polonaise";    
	nom[0].kind = (const char*) "contexte"; 
	nom[1].id   = (const char*) "usine";
	nom[1].kind = (const char*) "objet";

  
	// On recupere la reference de l'objet
	// en question
	//	
	CORBA::Object_var obj = import(orb,nom);


	//  On effectue un "cast" dynamique
	//	
	polonaise::usine_var usn = polonaise::usine::_narrow(obj);
	if (CORBA::is_nil(usn))
		ERREUR(FALSE,"Pb usn == is_nil \n");



	//
	// On demande a l'usine de construire
	// un objet "conversion"
	polonaise::conversion_var calc;
	usn->creationConversion(10,calc);



	//
	// A partir d'ici, on peut invoquer l'objet
	// comme un objet C++ classique
	// (attention, le dernier appel genere volontairement
	// une exception ... pour voir !)

	cout<<"La pile a pour taille maximale :"<<calc->taillePile()<<endl;

	polonaise::operandes donnees(4);
	donnees.length(4);

	donnees[0].element= (const char*) "10";
	donnees[0].type=polonaise::binaire;
	donnees[1].element= (const char*) "2";
	donnees[1].type=polonaise::decimal;
	donnees[2].element= (const char*) "100";
	donnees[2].type=polonaise::binaire;
	donnees[3].element= (const char*) "aa";
	donnees[3].type=polonaise::hexadecimal;

	calc->empileDonnee(donnees);

	polonaise::opes op(3);
	op.length(3);
	op[0]=polonaise::addition;
	op[1]=polonaise::addition;
	op[2]=polonaise::addition;
	calc->empileOperateur(op);

	// ca doit faire 178
	polonaise::operande resultat;
	resultat.element= (const char*) "";
	resultat.type=polonaise::binaire;
	
	CORBA::Long tailleCourante=calc->depileResultat(resultat);

	cout<<"Resultat = "<<resultat.element<<" Taille de la pile = "<<tailleCourante<<endl;


	// Conversion en decimal
	polonaise::operande vers;
	vers.element= (const char*) "";
	vers.type=polonaise::decimal;

	calc->convertir(resultat,vers);
	cout<<"Conversion : "<<vers.element<<endl;
	


	// oups, une de trop !!
	//tailleCourante=calc->depileResultat(resultat);
	

	//
	// On demande a l'usine de detruire
	// l'objet "conversion"
	usn->destructionConversion(calc);

   }

	// 
	// Ici, on tente de capter les exceptions
	//


	// D'abord les exceptions utilisateur 

  	catch(polonaise::erreur& ex) {
	    		cerr << "Exception utilisateur module polonaise" << endl;
	    		cerr << "Code erreur = "<<ex.codeErreur<<endl;
	  	}



	// Ensuite, les exceptions standards

	catch(CORBA::COMM_FAILURE& ex)  {
		cerr <<"Exception COMM_FAILURE, impossible de  "
			         << "contacter l'objet" << endl;
		}
 	catch(omniORB::fatalException& ex) {
		    cerr << "Caught omniORB2 fatalException. This indicates a bug is caught "
		         << "within omniORB2.\nPlease send a bug report.\n"
		         << "The exception was thrown in file: " << ex.file() << "\n"
		         << "                            line: " << ex.line() << "\n"
		         << "The error message is: " << ex.errmsg() << endl;
		  }


	// Et finalement, le reste du monde

  	catch(...) {
	    		cerr << "Exception systeme !" << endl;
	  	}



  return 0;
}



