
#include <stdlib.h>
#include "conversion_impl.hh"
#include "erreur.hh"
#include "ltostr.hh"

//
// Ceci est l'implantation de la classe
// specifiee dans conversion_impl.hh
//



conversion_impl::conversion_impl(int taille)
{
	donnees=new CORBA::Long[taille];
	if(donnees==NULL)
		ERREUR(FALSE,"Pb alloc pile\n");

	sommet=-1;
	tailleMax=taille;
}


conversion_impl::~conversion_impl()
{
	delete donnees;
	cout<<"Destruction de conversion_impl"<<endl;
}


CORBA::Long conversion_impl::taillePile(void)
{
	return tailleMax;
}


CORBA::Long conversion_impl::empileDonnee (const polonaise::operandes& donnees)
{
	for(unsigned int i=0;i<donnees.length();i++)
		{
		switch(donnees[i].type)
			{
			case polonaise::decimal: 	empiler(strtol(donnees[i].element,(char**)NULL,10));
							break;
			case polonaise::binaire: 	empiler(strtol(donnees[i].element,(char**)NULL,2));
							break;
			case polonaise::hexadecimal: 	empiler(strtol(donnees[i].element,(char**)NULL,16));
							break;
			}
		} 

	return(sommet+1);
}


CORBA::Long conversion_impl::empileOperateur (const polonaise::opes&  op)
{

	for(unsigned int i=0;i<op.length();i++)
		{
		long operande1=depiler();
		long operande2=depiler();

		switch(op[i])		
			{
			case polonaise::addition:		empiler(operande1+operande2);
								break;
			case polonaise::soustraction:		empiler(operande1-operande2);
								break;
			case polonaise::division:		empiler(operande1/operande2);
								break;
			case polonaise::multiplication:		empiler(operande1*operande2);
								break;
			}
		}
	return(sommet+1);
}


CORBA::Long conversion_impl::depileResultat (polonaise::operande& res)
{

	long resultat=depiler();
	switch(res.type)		
		{
		case polonaise::decimal:		ltostr(resultat,res.element,10);
							break;
		case polonaise::binaire:		ltostr(resultat,res.element,2);
							break;
		case polonaise::hexadecimal:		ltostr(resultat,res.element,16);
							break;
		}
	
	return(sommet+1);
}


void conversion_impl::convertir(const polonaise::operande& de, polonaise::operande& vers)
{

	CORBA::Long resultat;


	switch(de.type)		
		{
		case polonaise::decimal:		resultat=strtol(de.element,(char**)NULL,10);
							break;
		case polonaise::binaire:		resultat=strtol(de.element,(char**)NULL,2);
							break;
		case polonaise::hexadecimal:		resultat=strtol(de.element,(char**)NULL,16);
							break;
		}
	switch(vers.type)		
		{
		case polonaise::decimal:		ltostr(resultat,vers.element,10);
							break;
		case polonaise::binaire:		ltostr(resultat,vers.element,2);
							break;
		case polonaise::hexadecimal:		ltostr(resultat,vers.element,16);
							break;
		}
}



CORBA::Long conversion_impl::depiler(void)
{
	CORBA::Long res;

	if(sommet==-1)
		throw polonaise::erreur(polonaise::pileVide);
	else	{
		res=donnees[sommet];
		sommet--;
		}
		
	return res;
}

void conversion_impl::empiler(CORBA::Long element)
{
	if(sommet==(tailleMax-1))
		throw polonaise::erreur(polonaise::pilePleine);
	else	{
		sommet++;
		donnees[sommet]=element;
		}
}




