

#include "polonaise.hh"
#include "usine_impl.hh"
#include "flottant_impl.hh"
#include "conversion_impl.hh"
      



extern CORBA::BOA_ptr boa;



usine_impl::usine_impl()
{
	nbObjet=0;
}



void usine_impl::creationFlottant(CORBA::Long pile, polonaise::flottant_ptr & obj )
{


	if(nbObjet==maxObjets)
		throw polonaise::erreur(polonaise::maxAtteint);


	flottant_impl *flot = new flottant_impl(pile);
	if (flot==NULL)
		throw polonaise::erreur(polonaise::plusDeMemoire);

	boa->obj_is_ready(flot);

	obj = flot->_this();
	nbObjet++;

	cout<<"Creation d'un objet"<<endl;
}



void usine_impl::creationConversion(CORBA::Long pile, polonaise::conversion_ptr & obj )
{


	if(nbObjet==maxObjets)
		throw polonaise::erreur(polonaise::maxAtteint);


	conversion_impl *conv = new conversion_impl(pile);
	if (conv==NULL)
		throw polonaise::erreur(polonaise::plusDeMemoire);

	boa->obj_is_ready(conv);

	obj = conv->_this();
	nbObjet++;

	cout<<"Creation d'un objet"<<endl;
}




void usine_impl::destructionFlottant(polonaise::flottant_ptr obj)
{

	boa->dispose(obj);
	nbObjet--;

	cout<<"Destruction d'un objet"<<endl;
}


void usine_impl::destructionConversion(polonaise::conversion_ptr obj)
{

	boa->dispose(obj);
	nbObjet--;

	cout<<"Destruction d'un objet"<<endl;
}









